;																		
;																		
; Dieses Assembler-Programm	generiert ein VGA-SIGNAL					
;																		
;																		
; 640x480 - 60HZ 														
; 																		
; 180x160 PIXEL															
;																		
; ATmega1284P-22MHz (bertaktet mit 10%)								
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 06/2015														
;																		

;																		
; GRN leuchtet: alle-ok und alles schn								
; GELB leuchtet:														
; ROT  leuchtet: die automatische Taktkorrektur im Interrupt versagt	
; ROT+GELB leuchtet: Zeilennummern stimmen nicht 						

;																		
; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		

;																		
; Die Pixel generiert der PORT-B, ist aber	dadurch komplett belegt		
;																		


;												
; Anschlussbelegung PINS						
;												
; PA0 ==> 										
; PA1 ==> 										
; PA2 ==> 										
; PA3 ==> 										
; PA4 ==> 										
; PA5 ==> 										
; PA6 ==> 										
; PA7 ==> 										
;												
; PB0 ==> ROT									
; PB1 ==> GRN									
; PB2 ==> BLAU									
; PB3 ==>										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> TEST-AUSGANG-B						
; PC4 ==> TEST-AUSGANG-A						
; PC5 ==> LED GRN								
; PC6 ==> LED GELB								
; PC7 ==> LED ROT								
;												
; PD0 ==> VSYNC									
; PD1 ==> HSYNC									
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> OUT ca.32kHz							
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT									= 22000000	; 22 MHz		
; VGA											
.equ VGA_X									= 180
.equ VGA_Y									= 160
.equ VGA_ZEILEN_PRO_PIXEL					= 3
.equ VGA_BYTES_PRO_ZEILE					= 90
; TIMER-0-WERTE	(RESERVE)						
.equ TIMER0_CTC_FREQUENZ					= 10000
.equ TIMER0_N								= 8
.equ TIMER0_CTC								=(TAKT/(2*TIMER0_N*TIMER0_CTC_FREQUENZ))-1
.equ TIMER0_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER0_N)*(1+TIMER0_CTC))
; TIMER-1-WERTE	(VGA-BILD)						
.equ TIMER1_CTC_FREQUENZ					= 31496/2
.equ TIMER1_N								= 1
.equ TIMER1_CTC								=(TAKT/(2*TIMER1_N*TIMER1_CTC_FREQUENZ))-1
.equ TIMER1_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER1_N)*(1+TIMER1_CTC))
; TIMER-2-WERTE (ca. 32kHz fr Sensor)			
.equ TIMER2_CTC_FREQUENZ					= 32000
.equ TIMER2_N								= 8
.equ TIMER2_CTC								=(TAKT/(2*TIMER2_N*TIMER2_CTC_FREQUENZ))-1
.equ TIMER2_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER2_N)*(1+TIMER2_CTC))
; TIMER-3-WERTE (20ms fr Uhr + DCF)			
.equ TIMER3_CTC_FREQUENZ					= 25
.equ TIMER3_N								= 64
.equ TIMER3_CTC								=(TAKT/(2*TIMER3_N*TIMER3_CTC_FREQUENZ))-1
.equ TIMER3_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER3_N)*(1+TIMER3_CTC))
; TEST-B-PIN									
.equ TESTB_PIN_NR							= 3
.equ TESTB_DDR								= DDRC
.equ TESTB_PORT								= PORTC
; TEST-A-PIN									
.equ TESTA_PIN_NR							= 4
.equ TESTA_DDR								= DDRC
.equ TESTA_PORT								= PORTC
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR						= 5
.equ LED_GRUEN_DDR							= DDRC
.equ LED_GRUEN_PORT							= PORTC
; LED-GELB										
.equ LED_GELB_PIN_NR						= 6
.equ LED_GELB_DDR							= DDRC
.equ LED_GELB_PORT							= PORTC
; LED-ROT										
.equ LED_ROT_PIN_NR							= 7
.equ LED_ROT_DDR							= DDRC
.equ LED_ROT_PORT							= PORTC
; VGA-RGB-DATA-PORT								
.equ RGB_DATA_DDR							= DDRB
.equ RGB_DATA_PORT							= PORTB
; VGA-ROT-GRN-BLAU								
.equ R_DATA_PIN_NR							= 0
.equ G_DATA_PIN_NR							= 1
.equ B_DATA_PIN_NR							= 2
; VGA-V-SYNCHRON(BILDANFANG)					
.equ VSYNC_PIN_NR							= 0
.equ VSYNC_DDR								= DDRD
.equ VSYNC_PORT								= PORTD
; VGA-H-SYNCHRON (ZEILE)						
.equ HSYNC_PIN_NR							= 1
.equ HSYNC_DDR								= DDRD
.equ HSYNC_PORT								= PORTD
; REGISTER												
.def HILFSREGISTER_R0=R0	; wichtiges Rechenregister	
.def HILFSREGISTER_R1=R1	; wichtiges Rechenregister	
.def HILFSREGISTER_R2=R2	; wichtiges Rechenregister	
.def HILFSREGISTER_R3=R3	; wichtiges Rechenregister	
.def HILFSREGISTER_R4=R4	; wichtiges Rechenregister	
.def HILFSREGISTER_R5=R5	; wichtiges Rechenregister	
.def HILFSREGISTER_R6=R6	; wichtiges Rechenregister	
.def HILFSREGISTER_R7=R7	; wichtiges Rechenregister	
.def SREG_KOPIE		= R8	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def temp_KOPIE		= R9	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YL_KOPIE		= R10	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YH_KOPIE		= R11	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZL_KOPIE		= R12	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZH_KOPIE		= R13	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def NULL 			= R14	; ist immer NULL 	
.def EINS 			= R15	; ist immer EINS 	
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_DATEN						=SRAM_START+0		
	
.equ adr_MODUS_START				=SRAM_START+1		; Modus bei Programmstart	
.equ adr_MODUS						=SRAM_START+2		; MODUS (z.B. 1=Uhr)		
.equ adr_MENUE						=SRAM_START+3		; MENUE						
.equ adr_ERROR_CODE					=SRAM_START+4		; ERROR CODE 				
.equ adr_ERROR_WERT					=SRAM_START+5		; ERROR CODE (WERT)			
.equ adr_WARNUNG_CODE				=SRAM_START+6		; Warnung Code				
.equ adr_WARNUNG_WERT				=SRAM_START+7		; Warnung Code (WERT)		



.equ adr_ss20						=SRAM_START+700		; 20ms Sekunden				
.equ adr_ss							=SRAM_START+701		; Sekunden					
.equ adr_mm							=SRAM_START+702		; Minuten					
.equ adr_hh							=SRAM_START+703		; Stunden					
.equ adr_TAG						=SRAM_START+704		; TAG						
.equ adr_MONAT						=SRAM_START+705		; Monat						
.equ adr_JAHR						=SRAM_START+706		; JAHR						
.equ adr_WOCHENTAG					=SRAM_START+707		; 1=Mo 7=So					
.equ adr_MESZ						=SRAM_START+708



.equ adr_GRAFIC_FARBE				=SRAM_START+1100		; 0=wei 1=schwarz			
.equ adr_GRAFIC_PUNKT_GROESSE		=SRAM_START+1102		; PUNKT-GRSSE 0...9		
.equ adr_GRAFIC_RADIUS_L			=SRAM_START+1103		; RADIUS					
.equ adr_GRAFIC_RADIUS_H			=SRAM_START+1104		; RADIUS					
.equ adr_GRAFIC_WINKEL_L			=SRAM_START+1105		; WINKEL					
.equ adr_GRAFIC_WINKEL_H			=SRAM_START+1106		; WINKEL					
.equ adr_GRAFIC_LAENGE_L			=SRAM_START+1107		; STRECKEN-LNGE			
.equ adr_GRAFIC_LAENGE_H			=SRAM_START+1108		; STRECKEN-LNGE			
.equ adr_GRAFIC_ASCII_CURSOR_ZEILE	=SRAM_START+1112		; CURSOR VGA-ZEILE 			
.equ adr_GRAFIC_ASCII_CURSOR_SPALTE	=SRAM_START+1114		; CURSOR-SPALTE (0..		


.equ adr_VGA_TURBO_ON				=SRAM_START+1500
.equ adr_VGA_TURBO_OFF				=SRAM_START+1501
.equ adr_VGA_TURBO_DUMMY			=SRAM_START+1502
.equ adr_VGA_BILDZEILEN_NR_L		=SRAM_START+1503		; BILD-ZEILENNUMMER					
.equ adr_VGA_BILDZEILEN_NR_H		=SRAM_START+1504
.equ adr_VGA_ZEIGER_DATA_L			=SRAM_START+1505		; ZEIGER fr BILD-DATEN				
.equ adr_VGA_ZEIGER_DATA_H			=SRAM_START+1506
.equ adr_VGA_PIXEL_ZEILEN_COUNTER	=SRAM_START+1507		; PIXELZEILE						
.equ adr_VGA_BILD_ZEILE				=SRAM_START+1508
.equ adr_VGA_TURBO_BEREICH160		=SRAM_START+1510

.equ adr_VGA_BILDBEREICH			=SRAM_START+1800		; BILDSPEICHER						
.equ adr_VGA_BILDBEREICH_ENDE		=SRAM_START+1800+14400-1;(180x160/2 = 14.400 Bytes)			

.equ adr_SRAM_CHECK					=SRAM_START+16300		; SRAM CHECK muss immer "S" sein	
.equ adr_SRAM_END					=SRAM_START+16383		; 


;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp TIM1_COMPA ; Timer1 CompareA				
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;TIM1_OVF 	; Timer1 Overflow				
.org 0x0020 rjmp INTERRUPT_ERROR ;TIM0_COMPA ; Timer0 CompareA				
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp INTERRUPT_ERROR ;rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	call SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; DATUM				
	ldi temp,31
	STS(adr_TAG),temp
	ldi temp,12
	STS(adr_MONAT),temp
	ldi temp,15
	STS(adr_JAHR),temp
	ldi temp,4
	STS(adr_WOCHENTAG),temp
	; ZEIT				
	ldi temp,23
	STS(adr_hh),temp	; hh	
	ldi temp,58
	STS(adr_mm),temp	; mm	
	ldi temp,30
	STS(adr_ss),temp	; ss	
	ldi temp,0
	STS(adr_MESZ),temp	; MESZ	
; PORT A+B+C+D initialisieren (alles EINGNGE+PULL-UP aus)	
	out DDRA, NULL
	out PORTA,NULL
	out DDRB, NULL
	out PORTB,NULL
	out DDRC, NULL
	out PORTC,NULL
	out DDRD, NULL
	out PORTD,NULL
; LED_INITIALISIERUNG										
	call LED_INITIALISIERUNG
; VGA_PIN_INITIALISIERUNG									
	call VGA_PIN_INITIALISIERUNG
; WDR_INITIALISIERUNG										
	call WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR											
	call NEUSTART_MIT_WDR
; TIMER INITALISIERUNG										
;	call TIMER0_INITIALISIERUNG_CTC
	call TIMER1_INITIALISIERUNG_CTC	; VGA-BILD				
	call TIMER2_INITIALISIERUNG_CTC	; FREQUENZ				
	call TIMER3_INITIALISIERUNG_CTC	; UHR					
; Interrupts freigeben										
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EINSCHWINGEN												
	call GRAFIC_CLEAR
	call VGA_TEST_RAND_PIXEL
	call LED_TEST 								; LED_TEST		
;-------------------------------------------------------------------------------
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus		
	call PROGRAMM_CHECK
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   	
	call wait_1s
	call wait_1s
	call wait_1s
;-------------------------------------------------------------------------------
	call VGA_TEST_FARBBALKEN
	call wait_1s
	call GRAFIC_CLEAR

	call VGA_TEST_ASCII
	call wait_1s
	call GRAFIC_CLEAR

	call VGA_TEST_SCHACHBRETT
	call wait_1s
	call GRAFIC_CLEAR

	call VGA_TEST_PUNKTGROESSE
	call wait_1s
	call wait_1s
	call wait_1s
	call GRAFIC_CLEAR

	call VGA_TEST_FARB_PIXEL
	call wait_1s
	call GRAFIC_CLEAR

	call ANZEIGE_BEGRUESSUNG
	call wait_1s
	call wait_1s
	call wait_1s
	call GRAFIC_CLEAR

	call ANZEIGE_SYSTEM_INFO
	call wait_1s
	call wait_1s
	call wait_1s
	call GRAFIC_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	call ANZEIGE_HAUPTMENUE
	call ANZEIGE_ERROR_CODE
	call PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "VGA_TIMER.asm"					; TIMER							
.include "VGA_BILD_MACRO.asm"				; BILDAUFBAU					
.include "VGA_BILD.asm"						; TIMER+BILDAUFBAU				
.include "VGA_GRAFIC.asm"					; GRAFIC allgemein				
.include "VGA_GRAFIC_PUNKT.asm"				; PUNKT							
.include "VGA_ASCII.asm"					; ASCII							
.include "VGA_ASCII_ALPHABET.asm"			; ASCII Alphabet				
.include "VGA_ANZEIGE.asm"					; ANZEIGE						
.include "VGA_ANZEIGE_ZAHLEN.asm"			; ZAHLEN						
.include "VGA_ANZEIGE_KURZ.asm"				; ANZEIGE						
.include "VGA_SONSTIGES.asm"				; sonstiges						
.include "VGA_GRAFIC_TESTS.asm"				; TESTBILDER					
.include "VGA_WAIT_22MHZ.asm"				; 20 MHz						
.include "VGA_TABELLE_ASCII_8x12.asm"		; TABELLE (umfangreich)			
; ##############################################################################
; ##############################################################################
; ##############################################################################

TEXT_BEGRUESSUNG_0:
.db "VGA 640x480 60Hz ",0
TEXT_BEGRUESSUNG_1:
.db " ",0
TEXT_BEGRUESSUNG_2:
.db "180 x 160 PIXEL",0
TEXT_BEGRUESSUNG_3:
.db " ",0
TEXT_BEGRUESSUNG_4:
.db "ASCII 22x13 (8x12) ",0
TEXT_BEGRUESSUNG_5:
.db " ",0
TEXT_BEGRUESSUNG_6:
.db "ATmega1284P 22MHz",0
TEXT_BEGRUESSUNG_7:
.db " ",0
TEXT_BEGRUESSUNG_8:
.db " ",0
TEXT_BEGRUESSUNG_9:
.db " ",0
TEXT_BEGRUESSUNG_10:
.db "DCF-77  RTC DS1307 ",0
TEXT_BEGRUESSUNG_11:
.db " ",0
TEXT_BEGRUESSUNG_12:
.db "V1 06/2015 ",0
